#pragma once
#include "StdAfx.h"

#include "RecentContactsPersistencePolicy.h"

template<class PersistencePolicy = CSqlitePolicy>
class CRecentContactsT : public PersistencePolicy
{
public:
	CRecentContactsT(FavoriteController* pControllerint, int nContactsSize = 10) : PersistencePolicy(nContactsSize)
	{
		m_pController = pControllerint;
	}
	virtual ~CRecentContactsT(void){}

	// if exist contact record , it will replace the record by new time
	BOOL AddContact(CString strMyUserID, CString strContactId, CTime timeContact)
	{
		if(!PersistencePolicy::Delete(strMyUserID, strContactId))
		{
			return FALSE;
		}
		return PersistencePolicy::Add(strMyUserID, strContactId, timeContact);
	}

	BOOL DeleteContact(CString strMyUserID, CString strContactId)
	{
		return PersistencePolicy::Delete(strMyUserID, strContactId);
	}

	BOOL GetAllContactByUserId(CString strMyUserId, deque<CString>* pDeqContactId)
	{
		return PersistencePolicy::GetAll(strMyUserId, pDeqContactId);
	}

	BOOL NotifyController(CString strContactID)
	{
		 return m_pController->OnNewRecentContact(strContactID);
	}

private:

	FavoriteController* m_pController;
};


typedef CRecentContactsT<CSqlitePolicy> CRecentContacts;
